﻿using System;
using EsbDecimals;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace EsbDecimalsTest
{
	/// <summary>
	/// 
	/// </summary>
	[TestClass]
	public class DecimalOpsTests
	{
		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (1.0m), 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (2.0m), DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (3.0m), DecimalGlobals.Sqrt3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (5.0m), DecimalGlobals.Sqrt5));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (10.0m), DecimalGlobals.Sqrt10));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (DecimalGlobals.Pi), DecimalGlobals.SqrtPi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt7 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Sqrt (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (0.04m), 0.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (123.4567890m * 123.4567890m), 123.4567890m));
		}


		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt10 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (2.0), DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sqrt11 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Sqrt (2), DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.IntPow (0.0m, 55)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (1.0m, 22), 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (1.0m, -22), 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (0.0m, -55), 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (-1.0m, 12), 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (-1.0m, 13), -1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2.0m, 4), 16.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2.0m, -4), 1.0m / 16.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2.5m, 2), 6.25m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow10 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2.5m, -2), 1.0m / 6.25m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow11 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2m, 24), 16777216.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow12 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2.0, 4), 16.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPow13 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPow (2, 4), 16.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void NthRoot1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.NthRoot (2.0m, 2), DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void NthRoot2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.NthRoot (2.0m, 3), DecimalGlobals.Cbrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void NthRoot3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.NthRoot (DecimalGlobals.Pi, 3), DecimalGlobals.CbrtPi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void NthRoot4 ()
		{
			decimal X = DecimalOps.IntPow (0.25m, 12);
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.NthRoot (X, 12), 0.25m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void NthRoot5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.NthRoot (2.0, 3), DecimalGlobals.Cbrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void NthRoot6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.NthRoot (2, 3), DecimalGlobals.Cbrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log1 ()
		{
			decimal X = DecimalOps.Log (1m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log2 ()
		{
			decimal X = DecimalOps.Log (DecimalGlobals.NaturalConstant);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log3 ()
		{
			decimal X = DecimalOps.Log (DecimalGlobals.SqrNaturalConstant);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log4 ()
		{
			decimal X = DecimalOps.Log (1.0m / DecimalGlobals.SqrNaturalConstant);
			Assert.IsTrue (CompareOps.SameValue (X, -2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log5 ()
		{
			decimal X = DecimalOps.Log (256.789m);
			Assert.IsTrue (CompareOps.SameValue (X, 5.5482547360074002357639148395414m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log6 ()
		{
			decimal X = DecimalOps.Log (2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Ln2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log7 ()
		{
			decimal X = DecimalOps.Log (2.0);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Ln2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log8 ()
		{
			decimal X = DecimalOps.Log (2);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Ln2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log101 ()
		{
			decimal X = DecimalOps.Log10 (1m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log102 ()
		{
			decimal X = DecimalOps.Log10 (10.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log103 ()
		{
			decimal X = DecimalOps.Log10 (100.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log104 ()
		{
			decimal X = DecimalOps.Log10 (0.01m);
			Assert.IsTrue (CompareOps.SameValue (X, -2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log105 ()
		{
			decimal X = DecimalOps.Log10 (256.789m);
			Assert.IsTrue (CompareOps.SameValue (X, 2.4095764160415971281230830903713m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log106 ()
		{
			decimal X = DecimalOps.Log10 (2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Log2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log107 ()
		{
			decimal X = DecimalOps.Log10 (2.0);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Log2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log108 ()
		{
			decimal X = DecimalOps.Log10 (2);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Log2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log21 ()
		{
			decimal X = DecimalOps.Log2 (1m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log22 ()
		{
			decimal X = DecimalOps.Log2 (2m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log23 ()
		{
			decimal X = DecimalOps.Log2 (1024.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 10.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log24 ()
		{
			decimal X = DecimalOps.Log2 (0.0625m);
			Assert.IsTrue (CompareOps.SameValue (X, -4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log25 ()
		{
			decimal X = DecimalOps.Log2 (256.789m);
			Assert.IsTrue (CompareOps.SameValue (X, 8.0044395932265811584534084567608m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log26 ()
		{
			decimal X = DecimalOps.Log2 (1024.0);
			Assert.IsTrue (CompareOps.SameValue (X, 10.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Log27 ()
		{
			decimal X = DecimalOps.Log2 (1024);
			Assert.IsTrue (CompareOps.SameValue (X, 10.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow1 ()
		{
			decimal X = DecimalOps.TenPow (0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow2 ()
		{
			decimal X = DecimalOps.TenPow (1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 10.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow3 ()
		{
			decimal X = DecimalOps.TenPow (-1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.1m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow4 ()
		{
			decimal X = DecimalOps.TenPow (2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 100.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow5 ()
		{
			decimal X = DecimalOps.TenPow (-2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.01m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow6 ()
		{
			decimal X = DecimalOps.TenPow (0.5m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt10));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow7 ()
		{
			decimal X = DecimalOps.TenPow (12.45m);
			Assert.IsTrue (CompareOps.SameValue (X, 2818382931264.4538191019236991551m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow8 ()
		{
			decimal X = DecimalOps.TenPow (2.0);
			Assert.IsTrue (CompareOps.SameValue (X, 100.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TenPow9 ()
		{
			decimal X = DecimalOps.TenPow (2);
			Assert.IsTrue (CompareOps.SameValue (X, 100.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow1 ()
		{
			decimal X = DecimalOps.TwoPow (0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow2 ()
		{
			decimal X = DecimalOps.TwoPow (1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow3 ()
		{
			decimal X = DecimalOps.TwoPow (-1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.5m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow4 ()
		{
			decimal X = DecimalOps.TwoPow (2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow5 ()
		{
			decimal X = DecimalOps.TwoPow (-2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.25m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow6 ()
		{
			decimal X = DecimalOps.TwoPow (0.5m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow7 ()
		{
			decimal X = DecimalOps.TwoPow (12.45m);
			Assert.IsTrue (CompareOps.SameValue (X, 5595.3008916660040452146378149482m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow8 ()
		{
			decimal X = DecimalOps.TwoPow (2.0);
			Assert.IsTrue (CompareOps.SameValue (X, 4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TwoPow9 ()
		{
			decimal X = DecimalOps.TwoPow (2);
			Assert.IsTrue (CompareOps.SameValue (X, 4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp1 ()
		{
			decimal X = DecimalOps.Exp (0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp2 ()
		{
			decimal X = DecimalOps.Exp (1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.NaturalConstant));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp3 ()
		{
			decimal X = DecimalOps.Exp (-1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1 / DecimalGlobals.NaturalConstant));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp4 ()
		{
			decimal X = DecimalOps.Exp (2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.SqrNaturalConstant));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp5 ()
		{
			decimal X = DecimalOps.Exp (-2.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1 / DecimalGlobals.SqrNaturalConstant));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp6 ()
		{
			decimal X = DecimalOps.Exp (0.5m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalOps.Sqrt (DecimalGlobals.NaturalConstant)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp7 ()
		{
			decimal X = DecimalOps.Exp (12.45m);
			Assert.IsTrue (CompareOps.SameValue (X, 255250.32262933461218960648692161m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp8 ()
		{
			decimal X = DecimalOps.Exp (2.0);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.SqrNaturalConstant));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Exp9 ()
		{
			decimal X = DecimalOps.Exp (2);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.SqrNaturalConstant));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow1 ()
		{
			decimal X = DecimalOps.Pow (4.5m, 0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow2 ()
		{
			decimal X = DecimalOps.Pow (1.2345678901234567890m, 1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.2345678901234567890m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow3 ()
		{
			decimal X = DecimalOps.Pow (1.2345678901234567890m, -1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1 / 1.2345678901234567890m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow4 ()
		{
			decimal X = DecimalOps.Pow (1.2345678901234567890m, 0.5m);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalOps.Sqrt (1.2345678901234567890m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow5 ()
		{
			decimal X = DecimalOps.Pow (2.0m, 10.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1024.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow6 ()
		{
			decimal X = DecimalOps.Pow (1024.0m, 0.1m);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow7 ()
		{
			decimal X = DecimalOps.Pow (3.0m, 3.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow8 ()
		{
			decimal X = DecimalOps.Pow (3.0, 3.0);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow9 ()
		{
			decimal X = DecimalOps.Pow (3, 3);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow10 ()
		{
			decimal X = DecimalOps.Pow (3.0m, 3.0);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow11 ()
		{
			decimal X = DecimalOps.Pow (3.0, 3.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow12 ()
		{
			decimal X = DecimalOps.Pow (3.0m, 3);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow13 ()
		{
			decimal X = DecimalOps.Pow (3, 3.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow14 ()
		{
			decimal X = DecimalOps.Pow (3.0, 3);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Pow15 ()
		{
			decimal X = DecimalOps.Pow (3, 3.0);
			Assert.IsTrue (CompareOps.SameValue (X, 27.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Sin (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin2 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin3 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.PiOver2);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin4 ()
		{
			decimal X = DecimalOps.Sin (-DecimalGlobals.PiOver2);
			Assert.IsTrue (CompareOps.SameValue (X, -1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin5 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.Pi);
			Assert.IsTrue (CompareOps.SameValue (X, 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin6 ()
		{
			decimal X = DecimalOps.Sin (-DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin7 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.ThreePiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin8 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.Pi + DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin9 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.PiOver3);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt3 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin10 ()
		{
			decimal X = DecimalOps.Sin (DecimalGlobals.PiOver6);
			Assert.IsTrue (CompareOps.SameValue (X, 0.5m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin11 ()
		{
			decimal X = DecimalOps.Sin (1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.8414709848078965066525023216303m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sin12 ()
		{
			decimal X = DecimalOps.Sin (1.0);
			Assert.IsTrue (CompareOps.SameValue (X, 0.8414709848078965066525023216303m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Cos (DecimalGlobals.PiOver2)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos2 ()
		{
			decimal X = DecimalOps.Cos (DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos3 ()
		{
			decimal X = DecimalOps.Cos (0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos4 ()
		{
			decimal X = DecimalOps.Cos (-DecimalGlobals.PiOver2);
			Assert.IsTrue (CompareOps.SameValue (X, 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos5 ()
		{
			decimal X = DecimalOps.Cos (DecimalGlobals.Pi);
			Assert.IsTrue (CompareOps.SameValue (X, -1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos6 ()
		{
			decimal X = DecimalOps.Cos (-DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos7 ()
		{
			decimal X = DecimalOps.Cos (DecimalGlobals.ThreePiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos8 ()
		{
			decimal X = DecimalOps.Cos (DecimalGlobals.Pi + DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos9 ()
		{
			decimal X = DecimalOps.Cos (DecimalGlobals.PiOver3);
			Assert.IsTrue (CompareOps.SameValue (X, 0.5m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos10 ()
		{
			decimal X = DecimalOps.Cos (DecimalGlobals.PiOver6);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt3 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos11 ()
		{
			decimal X = DecimalOps.Cos (1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 0.54030230586813971740093660744298m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cos12 ()
		{
			decimal X = DecimalOps.Cos (1.0);
			Assert.IsTrue (CompareOps.SameValue (X, 0.54030230586813971740093660744298m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SinCos1 ()
		{
			decimal SinX;
			decimal CosX;
			DecimalOps.SinCos (0.0m, out SinX, out CosX);
			Assert.IsTrue (CompareOps.SameValue (SinX, 0.0m));
			Assert.IsTrue (CompareOps.SameValue (CosX, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SinCos2 ()
		{
			decimal SinX;
			decimal CosX;
			DecimalOps.SinCos (DecimalGlobals.PiOver2, out SinX, out CosX);
			Assert.IsTrue (CompareOps.SameValue (SinX, 1.0m));
			Assert.IsTrue (CompareOps.SameValue (CosX, 0.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SinCos3 ()
		{
			decimal SinX;
			decimal CosX;
			DecimalOps.SinCos (DecimalGlobals.PiOver4, out SinX, out CosX);
			Assert.IsTrue (CompareOps.SameValue (SinX, DecimalGlobals.Sqrt2 / 2.0m));
			Assert.IsTrue (CompareOps.SameValue (CosX, DecimalGlobals.Sqrt2 / 2.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SinCos4 ()
		{
			decimal SinX;
			decimal CosX;
			DecimalOps.SinCos (1.0m, out SinX, out CosX);
			Assert.IsTrue (CompareOps.SameValue (SinX, 0.8414709848078965066525023216303m));
			Assert.IsTrue (CompareOps.SameValue (CosX, 0.54030230586813971740093660744298m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SinCos5 ()
		{
			decimal SinX;
			decimal CosX;
			DecimalOps.SinCos (1.0, out SinX, out CosX);
			Assert.IsTrue (CompareOps.SameValue (SinX, 0.8414709848078965066525023216303m));
			Assert.IsTrue (CompareOps.SameValue (CosX, 0.54030230586813971740093660744298m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Tan (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan2 ()
		{
			decimal X = DecimalOps.Tan (DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan3 ()
		{
			try
			{
				decimal X = DecimalOps.Tan (DecimalGlobals.PiOver2);
			}
			catch (ArithmeticException e)
			{
				e.ToString ();
			}
			catch
			{
				Assert.Fail ("Should have thrown an ArithmeticException");
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan4 ()
		{
			try
			{
				DecimalOps.Tan (DecimalGlobals.ThreePiOver2);
			}
			catch (ArithmeticException e)
			{
				e.ToString ();
			}
			catch
			{
				Assert.Fail ("Should have thrown an ArithmeticException");
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan5 ()
		{
			decimal X = DecimalOps.Tan (DecimalGlobals.PiOver6);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt3 / 3.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan6 ()
		{
			decimal X = DecimalOps.Tan (DecimalGlobals.PiOver3);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan7 ()
		{
			decimal X = DecimalOps.Tan (-DecimalGlobals.PiOver3);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.Sqrt3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan8 ()
		{
			decimal X = DecimalOps.Tan (DecimalGlobals.Pi - DecimalGlobals.PiOver3);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.Sqrt3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan9 ()
		{
			decimal X = DecimalOps.Tan (DecimalGlobals.Pi + DecimalGlobals.PiOver3);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Sqrt3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan10 ()
		{
			decimal X = DecimalOps.Tan (1.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.5574077246549022305069748074584m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Tan11 ()
		{
			decimal X = DecimalOps.Tan (1.0);
			Assert.IsTrue (CompareOps.SameValue (X, 1.5574077246549022305069748074584m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Rad1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Rad (180.0m), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Rad2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Rad (45.0m), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Rad3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Rad (180.0), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Rad4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Rad (45.0), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Rad5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Rad (180), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Rad6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Rad (45), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Deg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Rad2Deg (DecimalGlobals.Pi), 180.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Deg2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Rad2Deg (DecimalGlobals.PiOver4), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TanDeg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.TanDeg (45.0m), 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void TanDeg2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.TanDeg (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Asin (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Asin (1.0m), DecimalGlobals.PiOver2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Asin (-1.0m), -DecimalGlobals.PiOver2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Asin (DecimalGlobals.Sqrt2 / 2.0m), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Asin (-DecimalGlobals.Sqrt2 / 2.0m), -DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Asin (0.5m), DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Asin7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Asin (-0.5m), -DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Acos (1.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Acos (-1.0m), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Acos (0.0m), DecimalGlobals.PiOver2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Acos (DecimalGlobals.Sqrt2 / 2.0m), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Acos (-DecimalGlobals.Sqrt2 / 2.0m), DecimalGlobals.ThreePiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Acos (0.5m), DecimalGlobals.PiOver3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Acos7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Acos (-0.5m), DecimalGlobals.Pi - DecimalGlobals.PiOver3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Atan (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (1.0m), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (-1.0m), -DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan4 ()
		{
			decimal X = DecimalOps.Atan (DecimalGlobals.Sqrt3);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.PiOver3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan5 ()
		{
			decimal X = DecimalOps.Atan (-DecimalGlobals.Sqrt3);
			Assert.IsTrue (CompareOps.SameValue (X, -DecimalGlobals.PiOver3));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (DecimalGlobals.Sqrt3 / 3.0m), DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (-DecimalGlobals.Sqrt3 / 3.0m), -DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (4.2m), 1.3370531459259951942086396204366m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (-4.2m), -1.3370531459259951942086396204366m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan10 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (0.5m), 0.46364760900080611621425623146121m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan11 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan (-0.5m), -0.46364760900080611621425623146121m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan21 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Atan2 (0.0m, 0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan22 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (4.5m, 0.0m), DecimalGlobals.PiOver2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan23 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (-4.5m, 0.0m), -DecimalGlobals.PiOver2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan24 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Atan2 (0.0m, 4.5m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan25 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (0.0m, -4.5m), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan26 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (2.2m, 2.2m), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan27 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (-2.2m, 2.2m), -DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan28 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (2.2m, -2.2m), DecimalGlobals.ThreePiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan29 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (-2.2m, -2.2m), -DecimalGlobals.ThreePiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan210 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (DecimalGlobals.Sqrt3, 3.0m), DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan211 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (-DecimalGlobals.Sqrt3, 3.0m), -DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan212 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (DecimalGlobals.Sqrt3, -3.0m),
										  DecimalGlobals.Pi - DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan213 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2 (-DecimalGlobals.Sqrt3, -3.0m),
										  -DecimalGlobals.Pi + DecimalGlobals.PiOver6));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleRad (2.3m), 2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad2 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (-2.3m);
			Assert.IsTrue (CompareOps.SameValue (X, -2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleRad (DecimalGlobals.Pi), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad4 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (-DecimalGlobals.Pi);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad5 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AdjustAngleRad (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad6 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (12.0m * DecimalGlobals.TwoPi + 1.2m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad7 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (12.0m * DecimalGlobals.TwoPi - 1.2m);
			Assert.IsTrue (CompareOps.SameValue (X, -1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleRad (2.3m, true), 2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad9 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (-2.3m, true);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.TwoPi - 2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad10 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleRad (DecimalGlobals.Pi, true), DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad11 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (-DecimalGlobals.Pi, true);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.Pi));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad12 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AdjustAngleRad (0, true)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad13 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (DecimalGlobals.TwoPi, true);
			Assert.IsTrue (CompareOps.ValueIsZero (X));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad14 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (12.0m * DecimalGlobals.TwoPi + 1.2m, true);
			Assert.IsTrue (CompareOps.SameValue (X, 1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustRad15 ()
		{
			decimal X = DecimalOps.AdjustAngleRad (12.0m * DecimalGlobals.TwoPi - 1.2m, true);
			Assert.IsTrue (CompareOps.SameValue (X, DecimalGlobals.TwoPi - 1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleDeg (2.3m), 2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg2 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (-2.3m);
			Assert.IsTrue (CompareOps.SameValue (X, -2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleDeg (180.0m), 180.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg4 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (-180.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 180.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg5 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AdjustAngleDeg (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg6 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (12.0m * 360.0m + 1.2m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg7 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (12.0m * 360.0m - 1.2m);
			Assert.IsTrue (CompareOps.SameValue (X, -1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleDeg (2.3m, true), 2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg9 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (-2.3m, true);
			Assert.IsTrue (CompareOps.SameValue (X, 360.0m - 2.3m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg10 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AdjustAngleDeg (180.0m, true), 180.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg11 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (-180.0m, true);
			Assert.IsTrue (CompareOps.SameValue (X, 180.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg12 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AdjustAngleDeg (0.0m, true)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg13 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (360.0m, true);
			Assert.IsTrue (CompareOps.ValueIsZero (X));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg14 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (12.0m * 360.0m + 1.2m, true);
			Assert.IsTrue (CompareOps.SameValue (X, 1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AngleAdjustDeg15 ()
		{
			decimal X = DecimalOps.AdjustAngleDeg (12.0m * 360.0m - 1.2m, true);
			Assert.IsTrue (CompareOps.SameValue (X, 360m - 1.2m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Dms2Deg (0, 0, 0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Dms2Deg (10, 30, 0), 10.5m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Dms2Deg (10, 30, 36), 10.51m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg4 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Dms2Deg (0.0, 0.0, 0.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Dms2Deg (10.0, 30.0, 0.0), 10.5m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Dms2Deg (10.0, 30.0, 36.0), 10.51m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg7 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Dms2Deg (0.0m, 0.0m, 0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Dms2Deg (10.0m, 30.0m, 0.0m), 10.5m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Dms2Deg9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Dms2Deg (10.0m, 30.0m, 36.0m), 10.51m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SignXY1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.SignXY (-4.0m, 5.0m), 4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SignXY2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.SignXY (-4.0m, -5.0m), -4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SignXY3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.SignXY (4.0m, 5.0m), 4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SignXY4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.SignXY (4.0m, -5.0m), -4.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Ceiling1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Ceiling (0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Ceiling2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Ceiling (-0.123m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Ceiling3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Ceiling (123.0m), 123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Ceiling4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Ceiling (-123.0m), -123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Ceiling5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Ceiling (123.456m), 124.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Ceiling6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Ceiling (-123.456m), -123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.IntPart (0.123m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.IntPart (-0.123m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPart (123.456m), 123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPart (-123.456m), -123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart5 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.IntPart (0.123)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart6 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.IntPart (-0.123)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPart (123.456), 123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void IntPart8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.IntPart (-123.456), -123.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.FractionPart (123.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.FractionPart (-123.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.FractionPart (123.456m), 0.456m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.FractionPart (-123.456m), -0.456m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart5 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.FractionPart (123.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart6 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.FractionPart (-123.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.FractionPart (123.456), 0.456m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void FractionPart8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.FractionPart (-123.456), -0.456m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS1 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (0.0m, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, 0);
			Assert.AreEqual (Degrees, 0);
			Assert.AreEqual (Minutes, 0);
			Assert.IsTrue (CompareOps.ValueIsZero (Seconds));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS2 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (12.0m, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, 1);
			Assert.AreEqual (Degrees, 12);
			Assert.AreEqual (Minutes, 0);
			Assert.IsTrue (CompareOps.ValueIsZero (Seconds));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS3 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (-12.0, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, -1);
			Assert.AreEqual (Degrees, 12);
			Assert.AreEqual (Minutes, 0);
			Assert.IsTrue (CompareOps.ValueIsZero (Seconds));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS4 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (12.5m, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, 1);
			Assert.AreEqual (Degrees, 12);
			Assert.AreEqual (Minutes, 30);
			Assert.IsTrue (CompareOps.ValueIsZero (Seconds));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS5 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (-12.5, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, -1);
			Assert.AreEqual (Degrees, 12);
			Assert.AreEqual (Minutes, 30);
			Assert.IsTrue (CompareOps.ValueIsZero (Seconds));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS6 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (12.51m, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, 1);
			Assert.AreEqual (Degrees, 12);
			Assert.AreEqual (Minutes, 30);
			Assert.IsTrue (CompareOps.SameValue (Seconds, 36.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2DMS7 ()
		{
			int Degrees;
			int Minutes;
			decimal Seconds;
			int Sign;
			DecimalOps.Deg2Dms (-12.51, out Degrees, out Minutes, out Seconds, out Sign);
			Assert.AreEqual (Sign, -1);
			Assert.AreEqual (Degrees, 12);
			Assert.AreEqual (Minutes, 30);
			Assert.IsTrue (CompareOps.SameValue (Seconds, 36.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Rad2Grad (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Rad2Grad (DecimalGlobals.PiOver4), 50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Rad2Grad (-DecimalGlobals.PiOver4), -50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad4 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Rad2Grad (0.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Rad2Grad (1.5), 95.492965855137201461330258023509m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Rad2Grad (-1.5), -95.492965855137201461330258023509m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Rad2Grad7 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Rad2Grad (0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Deg2Grad (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Grad (45.0m), 50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Grad (-45.0m), -50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad4 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Deg2Grad (0.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Grad (45.0), 50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Grad (-45.0), -50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad7 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Deg2Grad (0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Grad (45), 50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Deg2Grad9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Deg2Grad (-45), -50.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Grad2Rad (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Rad (50.0m), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Rad (-50.0m), -DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad4 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Grad2Rad (0.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Rad (50.0), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Rad (-50.0), -DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad7 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Grad2Rad (0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Rad (50), DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Rad9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Rad (-50), -DecimalGlobals.PiOver4));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg1 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Grad2Deg (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg2 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Deg (50.0m), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Deg (-50.0m), -45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg4 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Grad2Deg (0.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Deg (50.0), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Deg (-50.0), -45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg7 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Grad2Deg (0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg8 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Deg (50), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Grad2Deg9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Grad2Deg (-50), -45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AtanDeg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AtanDeg (1.0m), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AtanDeg2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AtanDeg (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AtanDeg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AtanDeg (1.0), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AtanDeg4 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AtanDeg (0.0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AtanDeg5 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AtanDeg (1), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AtanDeg62 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AtanDeg (0)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2Deg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2Deg (4.0m, 4.0m), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan3Deg2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Atan2Deg (0.0m, 5.5m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2Deg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2Deg (-4.0m, 4.0m), -45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2Deg4 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2Deg (4.0, 4.0), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan3Deg5 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Atan2Deg (0.0, 5.5)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2Deg6 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2Deg (-4.0, 4.0), -45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2Deg7 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2Deg (4, 4), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan3Deg8 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.Atan2Deg (0, 5)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Atan2Deg9 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.Atan2Deg (-4, 4), -45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AsinDeg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AsinDeg (DecimalGlobals.Sqrt2 / 2.0m), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AsinDeg2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AsinDeg (0.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AsinDeg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AsinDeg (1.0m), 90.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AcosDeg1 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AcosDeg (DecimalGlobals.Sqrt2 / 2.0m), 45.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AcosDeg2 ()
		{
			Assert.IsTrue (CompareOps.ValueIsZero (DecimalOps.AcosDeg (1.0m)));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void AcosDeg3 ()
		{
			Assert.IsTrue (CompareOps.SameValue (DecimalOps.AcosDeg (0.0m), 90.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cosec1 ()
		{
			try
			{
				Decimal x = DecimalOps.Cosec (0.0m);
				Assert.Fail ("Expected an Exception");
			}
			catch
			{
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cosec2 ()
		{
			decimal X = DecimalOps.Cosec (DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m / DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cosec3 ()
		{
			decimal X = DecimalOps.Cosec (DecimalGlobals.PiOver2);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sec1 ()
		{
			decimal X = DecimalOps.Sec (0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sec2 ()
		{
			decimal X = DecimalOps.Sec (DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m / DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Sec3 ()
		{
			try
			{
				Decimal x = DecimalOps.Sec (DecimalGlobals.PiOver2);
				Assert.Fail ("Expected an Exception");
			}
			catch
			{
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cot1 ()
		{
			try
			{
				Decimal x = DecimalOps.Cot (0.0m);
				Assert.Fail ("Expected an Exception");
			}
			catch
			{
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cot2 ()
		{
			decimal X = DecimalOps.Cot (DecimalGlobals.PiOver4);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void Cot3 ()
		{
			decimal X = DecimalOps.Cot (DecimalGlobals.PiOver2);
			Assert.IsTrue (CompareOps.ValueIsZero (X));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void CosecDeg1 ()
		{
			try
			{
				Decimal x = DecimalOps.CosecDeg (0.0m);
				Assert.Fail ("Expected an Exception");
			}
			catch
			{
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void CosecDeg2 ()
		{
			decimal X = DecimalOps.CosecDeg (45.0);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m / DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void CosecDeg3 ()
		{
			decimal X = DecimalOps.CosecDeg (90);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SecDeg1 ()
		{
			decimal X = DecimalOps.SecDeg (0.0m);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SecDeg2 ()
		{
			decimal X = DecimalOps.SecDeg (45.0);
			Assert.IsTrue (CompareOps.SameValue (X, 2.0m / DecimalGlobals.Sqrt2));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void SecDeg3 ()
		{
			try
			{
				Decimal x = DecimalOps.SecDeg (90);
				Assert.Fail ("Expected an Exception");
			}
			catch
			{
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void CotDeg1 ()
		{
			try
			{
				Decimal x = DecimalOps.CotDeg (0.0m);
				Assert.Fail ("Expected an Exception");
			}
			catch
			{
			}
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void CotDeg2 ()
		{
			decimal X = DecimalOps.CotDeg (45.0);
			Assert.IsTrue (CompareOps.SameValue (X, 1.0m));
		}

		/// <summary>
		/// 
		/// </summary>
		[TestMethod]
		public void CotDeg3 ()
		{
			decimal X = DecimalOps.CotDeg (90);
			Assert.IsTrue (CompareOps.ValueIsZero (X));
		}
	}
}